<?php
/*
Plugin Name: WP GeoIP Country Redirect (shared on wplocker.com)
Description: WP GeoIP Country Redirect let's you drive away unwanted traffic.
Version: 2.2
Author: Crivion
Author URI: http://crivion.com
License: Commercial
*/

/* Logging utilities */
function wpgeoip_add_log($action, $message) {
	global $wpdb;
	$action = $wpdb->escape($action);
	$message = $wpdb->escape($message);
	$wpdb->query("INSERT INTO wpgeoip_log VALUES (null, '$action', '$message')");
}

/**
 * Install/Remove Database Table
 */
require_once 'wpgeoip_install.php';
register_activation_hook(__FILE__, 'wpgeoip_install');
register_deactivation_hook(__FILE__, 'wpgeoip_uninstall');


/**
 * Add CSS/JS
 */
add_action( 'admin_enqueue_scripts', 'wpgeoip_resources' );
function wpgeoip_resources() {

	wp_register_style( 'geoip_wp_admin_chosenCSS', plugin_dir_url(__FILE__) . '/assets/resources/chosen.min.css', false, '1.0.0' );
    wp_enqueue_style( 'geoip_wp_admin_chosenCSS' );

    wp_register_script( 'geoip_wp_admin_chosenJS', plugin_dir_url(__FILE__) . '/assets/resources/chosen.jquery.min.js', false, '1.0.0' );
    wp_enqueue_script( 'geoip_wp_admin_chosenJS' );

    wp_register_script( 'geoip_wp_admin_pluginJS', plugin_dir_url(__FILE__) . '/assets/resources/wpgeoip.js', false, '1.0.0' );
    wp_enqueue_script( 'geoip_wp_admin_pluginJS' );

}

/**
 * Add WP-Admin Pages
 */

// Add settings link on plugin page
function wpgeoip_settings_link($links) { 
  $url = admin_url('admin.php?page=wpgeoip-admin');
  $settings_link = '<a href="'.$url.'">Settings</a>'; 
  $mylinks = array($settings_link);
  return array_merge($links, $mylinks); 
}
 
$plugin = plugin_basename(__FILE__); 
add_filter("plugin_action_links_$plugin", 'wpgeoip_settings_link' );

require_once 'wpgeoip_rules.php';
require_once 'wpgeoip_noerror.php';
require_once 'wpgeoip-mass.php';
require_once 'wpgeoip.log.php';
require_once 'wpgeoip_noredirect.php';

function geoip_admin_menu() {
        add_menu_page('WP GeoIP', 'WP GeoIP', 'manage_options', 'wpgeoip-admin', 'wpgeoip_admin', plugin_dir_url(__FILE__) . '/assets/images/icon16x16.png');
        add_submenu_page('wpgeoip-admin', 'WP GeoIP', 'Wp GeoIP', 'manage_options', 'wpgeoip-admin' ,'wpgeoip_admin'); 
		add_submenu_page('wpgeoip-admin', 'WPGeoIP LOG', 'WpGeoIP LOG', 'manage_options', 'wpgeoip-log' ,'wpgeoip_log'); 
		add_submenu_page('wpgeoip-admin', 'WPGeoIP Mass Redirect', 'WpGeoIP Mass Redirect', 'manage_options', 'wpgeoip-admin-mass' ,'wpgeoip_mass_redirect');
		add_submenu_page('wpgeoip-admin', 'WPGeoIP NO Redirect', 'WPGeoIP NO Redirect', 'manage_options', 'wpgeoip-noredirect' ,'wpgeoip_noredirect'); 
    }

add_action('admin_menu', 'geoip_admin_menu');

/**
 * Add Redirect Function
 */
require_once 'wpgeoip_redirect.php';
add_action('wp_head', 'wpgeoip_redirect');
